package cn.iocoder.yudao.module.system.dal.mysql.worklog;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.system.controller.admin.worklog.vo.loginstance.LogInstancePageReqVO;
import cn.iocoder.yudao.module.system.dal.dataobject.worklog.LogInstanceDO;
import cn.iocoder.yudao.module.system.dal.dataobject.worklog.LogReadDo;
import cn.iocoder.yudao.module.system.service.worklog.dto.LogReadUserRespDTO;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * 日志实例的拓展 Mapper
 *
 * @author 符溶馨
 */
@Mapper
public interface LogInstanceMapper extends BaseMapperX<LogInstanceDO> {

    default PageResult<LogInstanceDO> selectPage(LogInstancePageReqVO reqVO, Long userId) {
        return selectPage(reqVO, new LambdaQueryWrapperX<LogInstanceDO>()
                .eqIfPresent(LogInstanceDO::getType, reqVO.getType())
                .eqIfPresent(LogInstanceDO::getDeptId, reqVO.getDeptId())
                .eqIfPresent(LogInstanceDO::getStartUserName, reqVO.getStartUserName())
                .betweenIfPresent(LogInstanceDO::getCreateTime, reqVO.getCreateTime())
                .ne(LogInstanceDO::getStartUserId, userId)
                .orderByDesc(LogInstanceDO::getId));
    }

    default PageResult<LogInstanceDO> selectMyPage(Long userId, LogInstancePageReqVO reqVO) {

        return selectPage(reqVO, new LambdaQueryWrapperX<LogInstanceDO>()
                .eq(LogInstanceDO::getStartUserId, userId)
                .eqIfPresent(LogInstanceDO::getType, reqVO.getType())
                .betweenIfPresent(LogInstanceDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(LogInstanceDO::getId));
    }

    List<LogReadUserRespDTO> selectRaedUser(Long deptId);
}