package cn.iocoder.yudao.module.system.service.worklog;

import cn.iocoder.yudao.module.system.dal.dataobject.worklog.LogReadDo;
import cn.iocoder.yudao.module.system.dal.mysql.worklog.LogReadMapper;
import cn.iocoder.yudao.module.system.service.worklog.dto.LogReadUserRespDTO;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 日志查看 Service 实现类
 *
 * @author 符溶馨
 */
@Service
@Validated
public class LogReadServiceImpl implements LogReadService{

    @Resource
    private LogReadMapper logReadMapper;

    @Override
    public void createLogRule(List<LogReadUserRespDTO> createReqVO, Long logInstanceId, Long startUserId) {

        List<LogReadDo> userInfoList = createReqVO.stream()
                .map(user -> {
                    LogReadDo logReadDo = new LogReadDo();
                    logReadDo.setLogInstanceId(logInstanceId);
                    logReadDo.setStartUserId(startUserId);
                    logReadDo.setReadUserDept(user.getDeptId());
                    logReadDo.setReadUserId(user.getUserId());
                    logReadDo.setReadStatus(0);
                    return logReadDo;
                })
                .collect(Collectors.toList());

        logReadMapper.insertBatch(userInfoList);
    }
}
